/*
    Operations.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to perform time shifting, time scaling and time folding on discrete time signals

class Operations
{
  Operations() {}
  
  DTDataPair DTOperate(DTDataPair data,float a,float b)
  {
    int[] nOut=new int[0];
    float[] xOut=new float[0];
    float nTemp;
    
    for (int i=0;i<=data.n.length-1;i++)
    {
      nTemp=(data.n[i]-b)/a;
      if (abs(a)>1)
      {
        if ((nTemp%1)==0)
        {
          nOut=append(nOut,int(nTemp));
          xOut=append(xOut,data.x[i]);
        }
      }
      else if (abs(a)<1)
      {
        nOut=append(nOut,int(nTemp));
        xOut=append(xOut,data.x[i]);
        for (int j=1;j<=round(1/abs(a))-1;j++)
        {
          nOut=append(nOut,int(nTemp)+j);
          xOut=append(xOut,0);
        }
      }
      else
      {
        nOut=append(nOut,int(nTemp));
        xOut=append(xOut,data.x[i]);
      }
    }
    if (a<0) xOut=reverse(xOut);
    data=new DTDataPair(nOut,xOut);
    return(data);
  }
}
